﻿
Public Class PersonaDos
    Implements IEquatable(Of PersonaDos)


    Private _nombre As String
    Private _dni As String

    Public Property Nombre() As String
        Get
            Return _nombre
        End Get
        Set(ByVal value As String)
            _nombre = value
        End Set
    End Property

    Public Property DNI() As String
        Get
            Return _dni
        End Get
        Set(ByVal value As String)
            _dni = value
        End Set
    End Property


    Public Sub New(ByVal nombre As String, ByVal dni As String)
        Me._nombre = nombre
        Me._dni = dni
    End Sub


#Region " Implements IEquatable(Of PersonaDos)"

    '-------------------------------------------------------------------
    'Interfaz IEquatable(Of T)
    'http://msdn.microsoft.com/es-es/library/ms131187.aspx
    'Determinar si dos objetos tienen el mismo VALOR.
    '-------------------------------------------------------------------
    'Para determinar si tienen la misma REFERENCIA utilizar la función
    'Object.ReferenceEquals (Método) 
    'http://msdn.microsoft.com/es-es/library/system.object.referenceequals.aspx
    '-------------------------------------------------------------------

    '-------------------------------------------------------------------
    'La interfaz IEquatable
    'http://msdn.microsoft.com/es-es/library/ms131190.aspx
    '-------------------------------------------------------------------
    ''' <summary>
    '''    Determina si dos objetos tienen el mismo valor
    ''' </summary>
    ''' <returns>
    '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
    '''    <para>True:  Si son Iguales</para>
    '''    <para>False: en caso contrario</para>
    ''' </returns>
    Public Overloads Function Equals(ByVal other As PersonaDos) As Boolean _
              Implements System.IEquatable(Of PersonaDos).Equals
        Return Equals(Me, other)
    End Function


    '-------------------------------------------------------------------
    '  Sombreado Object.Equals
    '  http://msdn.microsoft.com/es-es/library/system.object.equals.aspx
    '-------------------------------------------------------------------
    ''' <summary>
    '''    Determina si dos objetos tienen el mismo valor
    ''' </summary>
    ''' <returns>
    '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
    '''    <para>True:  Si son Iguales</para>
    '''    <para>False: en caso contrario</para>
    ''' </returns>
    Public Overloads Overrides Function Equals(ByVal obj As Object) As Boolean
        '-------------------------------------------------------------
        ' El parámetro, obj, debe ser del mismo tipo que la clase o el 
        ' tipo de valor que implementa esta interfaz
        '-------------------------------------------------------------
        If Not (obj.GetType Is Me.GetType) Then
            Return False
            '"Los objetos a comparar no son del mismo tipo")
        End If

        '-------------------------------------------------------------
        Dim unapersona As PersonaDos
        unapersona = CType(obj, PersonaDos)
        Return Equals(Me, unapersona)
    End Function




    '-------------------------------------------------------------------
    '  Sombreado Object.Equals
    '  http://msdn.microsoft.com/es-es/library/system.object.equals.aspx
    '-------------------------------------------------------------------
    '-------------------------------------------------------
    ' Aquí es donde se hace TODO el trabajo de comparación
    '-------------------------------------------------------
    ''' <summary>
    '''    Determina si dos objetos tienen el mismo valor
    ''' </summary>
    ''' <returns>
    '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
    '''    <para>True:  Si son Iguales</para>
    '''    <para>False: en caso contrario</para>
    ''' </returns>
    Public Overloads Shared Function Equals( _
                     ByVal per1 As PersonaDos, _
                     ByVal per2 As PersonaDos) _
                     As Boolean
        '-------------------------------------------------------
        ' Aquí es donde se hace TODO el trabajo de comparación
        '-------------------------------------------------------
        Dim resultado As Boolean = False

        If per1.DNI = per2.DNI Then
            resultado = True
        End If
        Return resultado

    End Function



    '-------------------------------------------------------------------
    'Instrucciones para implementar Equals y el operador de igualdad (==)
    'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
    '-------------------------------------------------------------------
    ''' <summary>
    '''   Devuelve un valor que indica si un objeto Dinero 
    '''   especificado es igual que otro objeto Dinero especificado. 
    ''' </summary>
    ''' <returns>
    '''    <para>Un valor <see cref="System.Boolean">lógico</see> que indica:</para>
    '''    <para>True:  Si son Iguales</para>
    '''    <para>False: en caso contrario</para>
    ''' </returns>
    Public Overloads Shared Operator =( _
                     ByVal per1 As PersonaDos, _
                     ByVal per2 As PersonaDos) _
                     As Boolean
        Return Equals(per1, per2)
    End Operator


    '-------------------------------------------------------------------
    'Instrucciones para implementar Equals y el operador de igualdad (==)
    'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
    '-------------------------------------------------------------------
    ''' <summary>
    '''   Devuelve un valor que indica si un objeto Dinero 
    '''   especificado es distinto que otro objeto Dinero especificado. 
    ''' </summary>
    ''' <returns>
    '''    <para>Un valor  <see cref="System.Boolean">lógico</see> que indica:</para>
    '''    <para>True:  Si son DIFERENTES</para>
    '''    <para>False: en caso contrario</para>
    ''' </returns>
    Public Overloads Shared Operator <>( _
                     ByVal per1 As PersonaDos, _
                     ByVal per2 As PersonaDos) _
                     As Boolean
        Return Not (Equals(per1, per2))
    End Operator


    '-------------------------------------------------------------------
    'Sombreado Object.GetHashCode
    'http://msdn.microsoft.com/es-es/library/system.object.gethashcode.aspx
    '-------------------------------------------------------------------
    ''' <summary>
    '''  Devuelve el código hash de esta instancia. 
    ''' </summary>
    Public Overrides Function GetHashCode() As Integer
        'http://msdn.microsoft.com/es-es/library/system.object.gethashcode.aspx
        'http://msdn.microsoft.com/es-es/library/7h9bszxx.aspx
        Return _dni.GetHashCode()
    End Function


#End Region




End Class
